#ifndef   HANK_CONFIG_H
#define   HANK_CONFIG_H

/* Copyright 2001, Todd Lewis <tlewis@mindspring.com>
 * Released under GNU GPL v2. */

/* configuration.h: configuration and default settings */


#define DEFAULT_SMODULE_DIR  "./smodule/"
#define DEFAULT_SMODULE  "simple"
#define DEFAULT_SYSTEM_LOG "console"
#define DEFAULT_CONFIGURATOR "xml"
#define DEFAULT_MEMCON "malloc"
#define DEFAULT_PAENGINE "pcap"
#define DEFAULT_MATCHER "simple"

#define THREAD_MODE_SINGLE 0
#define THREAD_MODE_THREAD_PER_PACKET 1
#define THREAD_MODE_DOUBLE_SIDED 2
#define THREAD_MODE_THREAD_POOL 3

struct memcon;
struct paengine;
struct system_log;
struct smodule_juggler;
struct collections;

struct configuration {
	int thread_mode;
	struct memcon *mc;
	struct paengine *pae;
	struct system_log *sl;
	struct smodule_juggler *sj;
	struct collections *cols;
	struct configurator *cr;
};

extern struct configuration *configuration;

#endif /* HANK_CONFIG_H */
