
#ifndef   HANK_EVENT_H
#define   HANK_EVENT_H

/* Copyright 2001, Todd Lewis <tlewis@mindspring.com>
 * Released under GNU GPL v2. */

/* event.h: defines event system*/

#include "smodule.h"
#include "types.h"
#include <libxml/entities.h>


typedef u_int32_t event_id;
typedef u_int32_t handler_id;

struct packet;

/* need to add some mechanism for parameters */
struct event {
	event_id id;
	int consumed;
	void *payload;
	struct event *next;
};

/* it'd be nice if this were automatic */
enum EVENT_HANDLERS {
	EH_INVALID = 0,
	EH_PAE = 1,
	EH_MATCHER = 2,
	EH_REPORTER = 3,
	EH_FIREWALL = 4,
	EH_GROUP = 5,
	EH_MAX = 255
};

#define EHMAJ 1
#define EHMIN 1

struct event_handler {
	struct smodule s;
	event_id (*create_event)(void);
	handler_id (*register_handler)(event_id incoming, event_id target, xmlNodePtr m);
	int (*unregister_handler)(handler_id handler);
	int (*set_handler_target)(event_id incoming, handler_id handler, event_id target);
	void (*handle_event)(struct packet *p);
};

extern void establish_rules(const char *xml_rule_file);
extern void handle_events(struct packet *p);

#endif /* HANK_EVENT_H */
