#ifndef HDT_BLOB_H
#define HDT_BLOB_H

#include "hdt.h"
#include "packet.h"
#include "types.h"

/* Need a cursor for ACBM, etc. searches indicating:
	present search position
	preceeding zone of interest
	other search state
Also need a iobuf-style series of blob's.
How to do all of this?  Consolidated or separate?  How not to pollute
blob space with ACBMisms?
*/

struct blob {
	unsigned char *blob;
	size_t len;
};

extern hdt_set hdt_blob_create(void);
extern void hdt_blob_destroy(hdt_set set);
extern hdt_prim hdt_blob_add(hdt_set set, prim_id prid, char *op, char *arg);
extern void hdt_blob_del(hdt_set set, hdt_prim prim);
extern int hdt_blob_match(hdt_set set, hdt_prim *prims, struct blob *val, \
	unsigned char *rbuf, char newbits);
extern char *hdt_blob_report(struct blob *val, struct memcon_context *c);

extern void build_blobs(void);

#endif /* HDT_BLOB_H */
