
#include "hank.h"
#include "ip_lookup.h"
#include "support.h"
#include <stdio.h>

static char rcsid[] = "$Id: ip_lookup_test.c,v 1.4 2001/11/10 01:45:33 tlewis Exp $";

/* routines to help in managing ip addresses */

struct ipv4_network netb;

struct tnets {
	const char *net;
	char mask;
};

#define N(b,c) {#b, c},
struct tnets t[] = {
#include "networks.X"
};
#undef N

#define A(x) #x ,
char *addresses[] = {
#include "a.X"
};
#undef A

static char
get_mask(u_int32_t addr)
{
	int i;

	for(i=0;i<32;i++){
		if((addr>>i)&1){
			return(i);
		}
	}
	return(32);
}

int
main(int argc, char *argv[])
{
	int i, num_nets, num_addrs;
	struct tnets *tp;
	prim_id p;

	if(argc<3){
		printf("Usage: %s <num nets> <num addrs>\n", argv[0]);
		exit(-1);
	}

	num_nets=atoi(argv[1]);
	num_addrs=atoi(argv[2]);
	printf("%i %i\n", num_nets, num_addrs);

	i=(sizeof(t)/sizeof(t[0]));
	if(num_nets>i)
		num_nets=i;

	/* initialize */
	for(i=i;i<num_nets;i++){
		tp=&t[i];
		netb.addr=inet_addr(tp->net);
		netb.mask=get_mask(inet_addr(t[i-1].net));
		p=register_net(&netb);
		if(p==0){
			printf("Aiee!  register_net() failed!\n");
			exit(-1);
		}
		printf("Registered %s/%i as %i.\n", tp->net, tp->mask, p);
	}

	i=(sizeof(addresses)/sizeof(addresses[0]));
	if(num_addrs>i)
		num_addrs=i;

	for(i=0;i<num_addrs;i++){
		printf("Host %s: ", addresses[i]);
		find_matches(inet_addr(addresses[i]));
	}
	return(0);
}
