#include "../../memcon.h"
#include <stdio.h>
#include <unistd.h>

/* FIXME */
extern memcon_cid 
memcon_create(memcon_cid context, const char* owner);

/* destroy context */
extern void 
memcon_destroy(memcon_cid c);

/* alloc */
extern void* 
memcon_alloc(memcon_cid c, size_t size);

/* free */
extern void 
memcon_free(memcon_cid c, void* chunk);

/* context evaluation */
extern void
dump_contexts(memcon_cid c, void (callback)(struct memcon_context*));


static const char *name = "FooBar";

static void
dumper_callback(struct memcon_context* n)
{
	printf("ID: %i\n", n->id);
	if(n->parent)
		printf("     parent: %i\n", n->parent->id);
	if(n->child)
		printf("      child: %i\n", n->child->id);
	if(n->prev)
		printf("       prev: %i\n", n->prev->id);
	if(n->next)
		printf("       next: %i\n", n->next->id);
	if(n->size!=0)
		printf("       size: %i\n", n->size);
	if(n->owner!=NULL)
		printf("      owner: %s\n", n->owner);
}

static void
create_c(int recursion, memcon_cid c)
{
	int i;
	memcon_cid d, e;
	char *foo;

	d=memcon_create(c, name);
	for(i=0;i<3;i++){
		e=memcon_create(d, name);
		foo=(char*)memcon_alloc(e, 1024);
	}

	if(recursion>0)
		create_c((recursion-1), d);

	printf("Dumping context at %i.\n", recursion);
	dump_contexts(d, &dumper_callback);
	printf("\n");
	fflush(stdout);

	memcon_destroy(d);
}

int
main(int argc, char *argv[])
{

	int i;

	if(argc>1){
		i=atoi(argv[1]);
	} else {
		i=1;
	}

	while(i--){
		create_c(12, 0);
	}

	return(0);
}

