#ifndef   HANK_MEMCON_H
#define   HANK_MEMCON_H

/* Copyright 2001, Todd Lewis <tlewis@mindspring.com>
 * Released under GNU GPL v2. */

/* memcon.h: memory context interface */

#include <stdlib.h>
#include "smodule.h"

#define MCVMAJ 1
#define MCVMIN 1

typedef int memcon_cid;

struct memcon_context;
struct memcon;

struct memcon_context {
	struct memcon_context *parent;
	struct memcon_context *child;
	struct memcon_context *prev;
	struct memcon_context *next;
	struct memcon *eng;
	int id;
	const char *owner;
	size_t size;
};

struct memcon {
	struct smodule s;
	struct memcon_context *(*create)(struct memcon_context *parent, const char *owner);
	void (*destroy)(struct memcon_context *c);
	void *(*alloc)(struct memcon_context *c, size_t size);
	void (*free)(struct memcon_context *c, void *chunk);
	void (*dump_contexts)(struct memcon_context *c, void (*callback)(struct memcon_context*));
};

extern struct memcon *master_memcon;

#endif /* HANK_MEMCON_H */
