static int
icmp_private_decompose (struct packet *p)
{
  struct capsule *e = p->encaps, *f;
  struct ICMP_Hdr *h;
  struct section *s, *t;


  while (e->next)
    e = e->next;

  h = (struct ICMP_Hdr *) e->payload;


  append_encap (p, protocols[0], e->payload_length, e->payload);
  f = e->next;
  f->pe = &icmp_pe;

  if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    exit (-1);

  if ((t = p->c->eng->alloc (p->c, sizeof (*t))) == NULL)
    exit (-1);

  s->section_id = ICMP_SECTION_Hdr;
  s->content = h;
  s->next = t;

/*
	printf("Adding icmp section: %i\n", h->type);
*/

  switch(h->type){

  	case 0:
  	case 8:
  		t->section_id=ICMP_SECTION_Echo;
		break;

  	case 3:
  		t->section_id=ICMP_SECTION_Unreachable;
		break;

  	case 4:
  		t->section_id=ICMP_SECTION_SourceQuench;
		break;

  	case 5:
  		t->section_id=ICMP_SECTION_Redirect;
		break;

  	case 11:
  		t->section_id=ICMP_SECTION_TTLexceeded;
		break;

  	case 12:
  		t->section_id=ICMP_SECTION_Parameter;
		break;

  	case 13:
  	case 14:
  		t->section_id=ICMP_SECTION_Timestamp;
		break;

  	case 15:
  	case 16:
  		t->section_id=ICMP_SECTION_Information;
		break;

	default:
		printf("AIEE!  Unrecognized icmp type: %i\\n", h->type);

  }
  t->content = &(h->payload);
  t->next=NULL;

  f->sections = s;

  return (0);
}

