static int
ipv4_private_decompose (struct packet *p)
{
  struct capsule *e = p->encaps, *f;
  struct IPV4_Hdr *h;
  struct section *s, *t;
  int i;
  unsigned char *oc;

  while (e->next)
    e = e->next;

  h = (struct IPV4_Hdr *) e->payload;

  append_encap (p, protocols[0], e->payload_length, e->payload);
  f = e->next;
  f->pe = &ipv4_pe;

  if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    exit (-1);
  s->section_id = IPV4_SECTION_Hdr;
  s->content = h;
  s->next = NULL;
  f->sections = s;
  f->length = e->payload_length;

	for(i=20;i<(h->header_length*4);){
		oc = &e->payload[i];

#if 0
		printf("Doing IP Option: %i\\n", oc[0]);
#endif

		if(oc[0]==0){
			/* EOL */
			break;

		} else if(oc[0]==1){
			/* noop */
			i++;

		} else if(oc[0]==130){
			/* security! */
			i += oc[1];
			t=s;
  			if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    			exit (-1);
			s->section_id = IPV4_SECTION_security_option;
			s->content = &oc[0];
			t->next=s;
			s->next=NULL;

		} else if(oc[0]==131){
			/* lsrr  */
			i += oc[1];
			t=s;
  			if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    			exit (-1);
			s->section_id = IPV4_SECTION_loose_source_and_record_route_option;
			s->content = &oc[0];
			t->next=s;
			s->next=NULL;

		} else if(oc[0]==137){
			/* ssrr */
			i += oc[1];
			t=s;
  			if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    			exit (-1);
			s->section_id = IPV4_SECTION_strict_source_and_record_route_option;
			s->content = &oc[0];
			t->next=s;
			s->next=NULL;

		} else if(oc[0]==7){
			/* rr */
			i += oc[1];
			t=s;
  			if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    			exit (-1);
			s->section_id = IPV4_SECTION_record_route_option;
			s->content = &oc[0];
			t->next=s;
			s->next=NULL;

		} else if(oc[0]==136){
			/* si */
			i += oc[1];
			t=s;
  			if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    			exit (-1);
			s->section_id = IPV4_SECTION_stream_identifier_option;
			s->content = &oc[0];
			t->next=s;
			s->next=NULL;

		} else if(oc[0]==68){
			/* it */
			i += oc[1];
			t=s;
  			if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    			exit (-1);
			s->section_id = IPV4_SECTION_internet_timestamp_option;
			s->content = &oc[0];
			t->next=s;
			s->next=NULL;
		} else {
			/* unrecognized IP option; skip */
		}
	}

  f->payload_length = (f->length - (4 * h->header_length));
  f->payload_protocol = (u_int32_t) ((HPN_IPV4 << 24) | h->protocol);
  f->payload = &(e->payload[(4 * h->header_length)]);

  return (0);
}

static prim_id 
ipv4_private_reg_prim (int field, char *op, char *arg)
{
	struct ipv4_sameip *s;

	if(!strcmp(op, "sameip")){
		int prid = ++gprid;

		if((s=malloc(sizeof(*s)))==NULL){
			fprintf(stderr, "Aiee!  Malloc failed; aborting.\n");
			exit(-1);
		}
		s->pid = prid;
		s->next=sameips;
		sameips=s;
		return(prid);
	}

	return(ipv4_stock_reg_prim(field, op, arg));
}

static int
ipv4_private_find_matches (struct capsule *e, struct prim_can *c)
{
	struct ipv4_sameip *s;
	struct section *t;
	struct IPV4_Hdr *h;
	int i;

	i=ipv4_stock_find_matches(e, c);

	/* hack; sameip detection. */
	for(t=e->sections;t;t=t->next){
		if(t->section_id == IPV4_SECTION_Hdr){
			h=t->content;
			if(h->source == h->destination){
				for(s=sameips;s;s=s->next)
					e->matches[s->pid] = 1;
				break;
			}
		}
	}

	return(i);
}


