
<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:fo="http://www.w3.org/1999/XSL/Format">

<xsl:output method="html"/>

<xsl:template match="miscelems"/>

<xsl:template match="desc">
<table border='2' fgcolor="#000000" bgcolor="#aa88ff">
<caption><B>Protocol description</B></caption>
<tr><td><xsl:apply-templates/></td></tr>
</table>
<hr/>
</xsl:template>

<xsl:template match="p">
<p><xsl:copy-of select="node()"/></p>
</xsl:template>

<xsl:template match="ref">
<b>Reference: </b> <xsl:apply-templates/>
<hr/>
</xsl:template>

<xsl:template match="rfc-ref">
<b>Reference: </b>
<a>
<xsl:attribute name="href">http://www.rfc-editor.org/rfc/rfc<xsl:copy-of select="node()"/>.txt</xsl:attribute>RFC-<xsl:apply-templates/></a>
<hr/>
</xsl:template>

<xsl:template match="pe">
<xsl:if test="@disabled!='yes'">
<HTML>
<HEAD>
<TITLE>Hank Protocol Engine Documentation for Protocol "<xsl:value-of select="name"/>"</TITLE>
</HEAD>
<xsl:apply-templates/>
</HTML>
</xsl:if>
</xsl:template>

<xsl:template match="name">
<b>Section: </b><xsl:copy-of select="node()"/>
<hr/>
</xsl:template>

<xsl:template match="rcsid">
<b>RCS ID: </b><xsl:copy-of select="node()"/>
<hr/>
</xsl:template>

<xsl:template match="protocols">
<table border='2' fgcolor="#000000" bgcolor="#aa88ff">
<caption>Protocols</caption>
<tr><td>Family</td><td>Number</td></tr>
<tr><xsl:apply-templates/></tr>
</table>
<hr/>
</xsl:template>

<xsl:template match="protocol">
<tr>
<td><xsl:value-of select="family"/></td>
<td><xsl:value-of select="number"/></td>
</tr>
</xsl:template>

<xsl:template match="endian">
<b>Endian: </b><xsl:copy-of select="node()"/>
<hr/>
</xsl:template>

<xsl:template match="decompose"/>

<xsl:template match="sections">
<B>Sections:</B><br/>
	<xsl:apply-templates/>
<hr/>
</xsl:template>

<xsl:template match="section">
<table border='2' fgcolor="#000000" bgcolor="#aa88ff">
<caption><b>Name: <xsl:value-of select="@name"/></b></caption>
<thead>
<tr>
<td>Field name</td>
<td>Field type</td>
<td>Field size</td>
<td>Field description</td>
</tr>
</thead>
<tbody>
<tr>
	<xsl:apply-templates/>
</tr>
</tbody>
</table>
</xsl:template>

<xsl:template match="reversal">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="custom_type">
<tr>
<td><xsl:value-of select="custom_type.name"/></td>
<td><xsl:value-of select="custom_type.type"/></td>
<td>-</td>
<td><xsl:copy-of select="node()"/></td>
</tr>
</xsl:template>

<xsl:template match="blob">
C <xsl:value-of select="@name"/>
 DELETE
</xsl:template>

<xsl:template match="blob">
<tr>
<td><xsl:value-of select="@name"/></td>
<td>Binary Large Object</td>
<td>-</td>
<td><xsl:copy-of select="node()"/></td>
</tr>
</xsl:template>

<xsl:template match="int32">
<tr>
<td><xsl:value-of select="@name"/></td>
<td>Integer</td>
<td><xsl:value-of select="@len"/></td>
<td><xsl:copy-of select="node()"/></td>
</tr>
</xsl:template>

<xsl:template match="custom_type">
<tr>
<td><xsl:value-of select="@name"/></td>
<td><xsl:value-of select="@type"/></td>
<td>-</td>
<td><xsl:copy-of select="node()"/></td>
</tr>
</xsl:template>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
