#ifndef   PROTOCOL_ENGINE_H
#define   PROTOCOL_ENGINE_H

/* Copyright 2001, Todd Lewis <tlewis@mindspring.com>
 * Released under GNU GPL v2. */

/* protocol_engine.h: protocol engine data structures */

#include "packet.h"
#include "smodule.h"
#include <stdlib.h>
#include "types.h"

/* smodule version numbers for interface; bump when interface changes */
#define PEVMIN 1
#define PEVMAJ 3

struct prim_can;
struct packet;

struct protocol_engine {
	struct smodule s;
	int     (*decompose)(struct packet *p);
	prim_id (*reg_prim)(int field, char *op, char *arg);
	int     (*unreg_prim)(prim_id i);
	int     (*find_matches)(struct capsule *e, struct prim_can *c);
	int     (*rewrite)(struct capsule *c, void *new_payload, size_t len);
	char *  (*report_field)(struct capsule *p, int field, struct memcon_context *m);
	int     (*field_lookup)(char *section, char *field);
	u_int32_t *protocols;
	u_int32_t capabilities;
};

#endif /* PROTOCOL_ENGINE_H */
