#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include "frob.h"
#include "smodule.h"

static const char*
my_mod_dirs[3] = {
	"./.modules1/",
	"./.modules2/",
	NULL
};

static void
test_frob(frob* f)
{
	printf("friendly_message is \"%s\"\n", f->friendly_message);
	printf("get_num_frobs() returns \"%i\"\n", f->get_num_frobs());
	printf("stringer() returns \"%s\"\n", f->stringer());
}

int
main(void)
{
	smcol_t c;
	smodule *s, *t;

	if((c=scan_collection("frobnicate", statics, my_mod_dirs, VMAJ, VMIN))<0){
		fprintf(stderr, "ERROR: Can't scan module collection.  Exiting.\n");
		exit(-1);
	}

	if((s=get_smodule(c, "smod1"))==NULL){
		fprintf(stderr, "Can't find module \"smod1\"!\n");
		exit(-1);
	}
	/* fprintf(stderr, "Found module \"smod1\" at %x.\n", s); */
	test_frob(s->interface);

	if((s=get_smodule(c, "dmod2"))==NULL){
		fprintf(stderr, "Can't find module \"dmod2\"!\n");
		exit(-1);
	}
	/* fprintf(stderr, "Found module \"dmod2\" at %x.\n", s); */
	test_frob(s->interface);

	if((t=get_smodule(c, "dmod2"))==NULL){
		fprintf(stderr, "Can't find module \"dmod2\"!\n");
		exit(-1);
	}
	/* fprintf(stderr, "Found module \"dmod2\" at %#x.\n", (void *)t); */
	test_frob(t->interface);

	release_smodule(c, t);
	fprintf(stderr, "Just released second instance of dmod2; testing first.\n");
	test_frob(s->interface);

	if((s=get_smodule(c, "nonexistent"))==NULL){
		fprintf(stderr, "Can't find module \"nonexistent\"; very good.\n");
	} else {
		fprintf(stderr, "ERROR: module \"decrepit\" loaded despite not existing!\n");
	}

	if((s=get_smodule(c, "decrepit"))==NULL){
		fprintf(stderr, "Can't find module \"decrepit\"; very good.\n");
	} else {
		fprintf(stderr, "ERROR: module \"decrepit\" loaded despite misversioning.\n");
	}

	if((s=get_smodule(c, "dtrouble"))==NULL){
		fprintf(stderr, "ERROR: module \"dtrouble\" not loaded.\n");
	} else {
		fprintf(stderr, "Found module \"dtrouble\"; good.\n");
		test_frob(s->interface);
	}

	return(c);
}

