#ifndef   SYSTEM_LOG_H
#define   SYSTEM_LOG_H

#include "smodule.h"
#include "types.h"

/*******************************************************************
 * system_log.h: interface for the system logger.  This system     *
 * allows hank to inform the operator of important events in the  *
 * system, like subsystem failures and errors; this is different   *
 * from communicating about IDS matches, which are handled via     *
 * processors.                                                     *
 *                                                                 *
 * (c) 2001, Todd Lewis, <tlewis@mindspring.com>                   *
 * Released under GNU GPL v2.                                            *
 *******************************************************************/

#define F(a,b) SLF_ ##a = b,
#define P(a,b)
enum SL_FACILITIES {
#include "system_log.X"
	SLF_UNDEFINED=0
};
#undef F
#undef P

#define P(a,b) SLP_ ##a = b,
#define F(a,b)
enum SL_PRIORITIES {
#include "system_log.X"
	SLP_UNDEFINED=0
};
#undef F
#undef P

#define SLVMAJ 1
#define SLVMIN 1

/* This is the structure exported as the "interface" from the smodule. */
struct system_log {
	struct smodule s;
   int (*init)(void);
   int (*close)(void); 
   int (*configure)(char * config);
	int (*log)(char *msg, unsigned int facility, unsigned int priority);
	u_int32_t fac_mask;
	u_int32_t pri_mask;
};

extern struct system_log *master_system_log;

#endif /* SYSTEM_LOG_H */
